#include <memory>
#include <iostream>

struct DebugStruct
{
	DebugStruct()
	{
		std::cout << "Constructor\n";
	}
	
	~DebugStruct()
	{
		std::cout << "Destructor\n";
	}
	
	void Print()
	{
		std::cout << "Salut lume\n";
	}
};

int main()
{
	// std::shared_ptr<DebugStruct> a(new DebugStruct);
	auto p = std::make_shared<DebugStruct>();
	std::cout << p.use_count() << '\n';
	
	std::shared_ptr<DebugStruct> q = p;
	std::cout << p.use_count() << '\n';
	
	std::weak_ptr<DebugStruct> m = p;
	std::cout << p.use_count() << '\n';
	
	p.reset();
	q.reset();
	std::cout << p.use_count() << '\n';
	
	std::shared_ptr<DebugStruct> n = m.lock();
	
	if (n)
	{
		n->Print();
	}
	else
	{
		std::cout << "Pointerul e null\n";
	}
	
	return 0;
}


